/* **********************************************************
 * Copyright 2002 VMware, Inc.  All rights reserved. -- VMware Confidential
 * **********************************************************/

#ifndef __VMHOST_H__
#define __VMHOST_H__

#define INCLUDE_ALLOW_MODULE
#include "includeCheck.h"

#include <linux/sched.h>
#include "compat_semaphore.h"
#include "compat_wait.h"

/*
 * Per-vm host-specific state.
 */

typedef struct VMHost {
   atomic_t           pendingUserCalls;
   wait_queue_head_t  callQueue;
   volatile Bool      replyWaiting[MAX_INITBLOCK_CPUS];
   wait_queue_head_t  replyQueue[MAX_INITBLOCK_CPUS];
   unsigned int       crosspagePagesCount;
   struct page        *crosspagePages[MAX_INITBLOCK_CPUS];
#ifdef KERNEL_2_4_0
   struct task_struct *vcpuSemaTask[MAX_INITBLOCK_CPUS];
#else
   poll_table         *vcpuSemaWait[MAX_INITBLOCK_CPUS];
#endif
   struct PhysTracker *allocatedPages;
} VMHost;

#endif
